import greenfoot.*;
public class Bullet extends Actor {
    private static final GreenfootImage
        BULLET_IMAGE = makeImage();
    private int speed = 10;
    private int damage = 2;
    
    public Bullet() {
        setImage(BULLET_IMAGE);
    }
    
    public void act() {
        setLocation(getX() + speed, getY());
        checkEnemyCollision();
        checkIsOnScreen();
    }
    
    private void checkEnemyCollision() {
        Enemy enemy = (Enemy)getOneIntersectingObject(Enemy.class);
        if(enemy != null) {
            enemy.damage(damage);
        }
    }
    
    private void checkIsOnScreen() {
        if(!isOnScreen()) {
            getWorld().removeObject(this);
        }
    }
    
    private boolean isOnScreen() {
        return getX() < getWorld().getWidth() - 1;
    }
    
    private static GreenfootImage makeImage() {
        GreenfootImage img = new GreenfootImage(10, 4);
        img.fill();
        return img;
    }
}
